      PROGRAM INPUT31
!***  MODIFIED ON 02 June, 2006 BY Y.NATH**********************
!*****modyinput4.for GENERATE THE DATA FILE BOTH FOR ANALYSIS**
!*****AND DESIGN CORRESPONDING TO NDES(1 OR 2)****************
!     THIS PROGRAM IS MODIFIED FROM THE PROGRAM 'INPUT3.FOR' FOR
!     PERFORMING INPUT DATA AND PREPARE AN OUTPUT DATA FILE FOR
!     PROGRAM ANDECAS4.
!
!     DEFINITIONS
!
!     FNAME - FILENAME OF A NEW FILE FOR ANDECASE4
!     NAXLE - NO. OF AXLES
!     NLINES - NO. OF LINES OF LOADS
!     SOLU - TYPE OF SOLUTION (NUMERICAL OR MATHEMATICAL/CLOSED FORM)
!          - N OR n FOR NUMERICAL
!          - M OR m FOR MATHEMATICAL/ CLOSED FORM
!
      PARAMETER (MAXAXLE=15)
      DIMENSION XU(MAXAXLE),YU(MAXAXLE),WU(MAXAXLE)
      CHARACTER FNAME*4,TITLE*20,SOLU*1
      INTEGER FIX8,FIX9,EDGE,CHBDC,UNFIX
!
!     NO. OF LINES OF LOADS ARE 4 IN ALL CASES EXCEPT USER DEFINED LOADS
!
      NLINES = 4
!
!     NO. OF AXLES ARE 5 IN ALL CASES EXCEPT USER DEFINED LOADS
!
      NAXLE = 5
!
      WRITE(6,700)
      WRITE(6,710)
      WRITE(6,720)
      WRITE(6,730)
      READ(6,740) FNAME
      WRITE(6,750) FNAME
!
      OPEN(UNIT=70,FILE=FNAME//'.DAT',STATUS='UNKNOWN')
!
!DESIGN COEFFS CONDITIONAL WITH NDES HENCE AFTERWARDS Yoge 06 June,06       
      WRITE(6,790)
      READ(6,*) YMIN
      WRITE(6,791)
      READ(6,*) WALLD
      WRITE(6,792)
      READ(6,*) WALLW
      WRITE(6,793)
      READ(6,*) CONCT
      WRITE(6,794)
      
      READ(6,*) WEART
      WRITE(6,795)
      READ(6,*) BMRAIL
      WRITE(6,796)
      READ(6,*) BS
      WRITE(6,797)
      READ(6,*) NLOAD
      WRITE(6,798)
      READ(6,*) NX
      WRITE(6,799)
      READ(6,*) NDES
      WRITE(6,800)
      READ(6,*) EDGE
      WRITE(6,760)
!** Following READ/WRITE ARE CONDITIONAL WITH NDES by NATH 06 June,06 
      IF(NDES.EQ.1) THEN
      WRITE(6,770)
      READ(6,*) ALPLL
      WRITE(6,771)
      READ(6,*) ALPDL1
      WRITE(6,772)
      READ(6,*) ALPDL2
      WRITE(6,773)
      READ(6,*) ALPDL3
      WRITE(6,774)
      READ(6,*) DLA
      WRITE(6,775)
      READ(6,*) PHIS
      WRITE(6,776)
      READ(6,*) PHIC
      WRITE(6,777)
      READ(6,*) RHOMIN
      WRITE(6,778)
      READ(6,*) FY
      WRITE(6,779)
      READ(6,*) FC
      ENDIF
      WRITE(6,780)
!
      FIX8=NLOAD
      FIX9=NX
      IF(FIX8.EQ.4) THEN
      WRITE(6,801)
      WRITE(6,803)
 803  FORMAT(/16X,'NO. OF AXLES = ')
      READ(6,*) NAXLE
      WRITE(6,804)
 804  FORMAT(/16X,'NO. OF LINES OF LOADS = ')
      READ(6,*) NLINES
      XU(1)=0.
      WRITE(6,808)
 808  FORMAT(//2X,'INPUT DATA FOR WHEEL POSITION')
      DO 10 I=2,NAXLE
      WRITE(6,805) I
 805  FORMAT(/16X,'POSITION OF AXLE NO. (',I2,') FROM 1st AXLE = ')
      READ(6,*) XU(I)
 10   CONTINUE
      WRITE(6,809)
 809  FORMAT(//2X,'INPUT DATA FOR SPACE OF WHEEL LINE FROM 2nd LINE')
      DO 20 I=2,NLINES
      WRITE(6,806) I
 806  FORMAT(/16X,'POSITION OF NO. (',I2,') LINE OF LOADS = ')
      READ(6,*) YU(I)
 20   CONTINUE
      DO 30 I=1,NAXLE
      WRITE(6,807) I
 807  FORMAT(/16X,'AXLE FORCE OF WHEEL NO. (',I2,') = ')
      READ(6,*) WU(I)
 30   CONTINUE
      ENDIF
!
      WRITE(6,820)
      WRITE(6,830)
      WRITE(6,840)
!  *** WRITE CONDITIONAL WITH NDES 06 JUNE,2006 By YOGENDRA*****
       IF(NDES.EQ.1) THEN
      WRITE(6,850) ALPLL,PHIS
      WRITE(6,860) ALPDL1,PHIC
      WRITE(6,870) ALPDL2,RHOMIN
      WRITE(6,880) ALPDL3,FY
      WRITE(6,890) DLA,FC
       ENDIF
      WRITE(6,820)
      PAUSE
      WRITE(6,*)
      WRITE(6,820)
      WRITE(6,1000)
      WRITE(6,1010)
      WRITE(6,1020) YMIN,BS
      WRITE(6,1030) WALLD,NLOAD
      WRITE(6,1040) WALLW,NX
      WRITE(6,1050) CONCT,NDES
      WRITE(6,1060) WEART,EDGE
      WRITE(6,1061) BMRAIL
      WRITE(6,820)
      PAUSE
!
      IF(FIX8.EQ.4) THEN
 102  CONTINUE
      WRITE(6,*)
      WRITE(6,820)
      WRITE(6,1065)
      WRITE(6,1070)
      MINSTEP=MIN(NAXLE,NLINES)
      DO 40 I=1,MINSTEP
      WRITE(6,1075) I,I,XU(I),(I+NAXLE),I,YU(I),(I+NAXLE+NLINES),I,WU(I)
 1075 FORMAT(1X,'#',I2,'.) XU(',I2,') = ',F8.3,5X,I2,'.) YU(',I2,') = '
     1,F8.3,5X,I2,'.) WU(',I2,') = ',F8.3,1X,'#')
 40   CONTINUE
      IF(NAXLE.GT.NLINES) THEN
      DO 50 I=MINSTEP+1,NAXLE
      WRITE(6,1076) I,I,XU(I),(I+NAXLE+NLINES),I,WU(I)
 1076 FORMAT(1X,'#',I2,'.) XU(',I2,') = ',F8.3,32X,I2,'.) WU(',I2,') = 
     1',F8.3,1X,'#')
 50   CONTINUE
      ENDIF
      IF(NAXLE.LT.NLINES) THEN
      DO 60 I=MINSTEP+1,NLINES
      WRITE(6,1077) (I+NAXLE),I,YU(I)
 1077 FORMAT(1X,'#',27X,I2,'.) YU(',I2,') = ',F8.3,28X,'#')
 60   CONTINUE
      ENDIF
      WRITE(6,820)
      WRITE(6,1155) NAXLE+NAXLE+NLINES
      READ(6,*) CHBDC
!
      IF(CHBDC.EQ.99) THEN
      WRITE(6,*) 'THIS PART IS COMPLETE, THANK YOU'
      WRITE(6,*)
      GOTO 140
      ELSEIF(CHBDC.GE.1.AND.CHBDC.LE.NAXLE) THEN
      WRITE(6,1231) CHBDC
 1231 FORMAT(/16X,'XU(',I2,') = ')
      READ(6,*) XU(CHBDC)
      ELSEIF(CHBDC.GE.(NAXLE+1).AND.CHBDC.LE.(NAXLE+NLINES)) THEN
      WRITE(6,1232) (CHBDC-NAXLE)
 1232 FORMAT(/16X,'YU(',I2,') = ')
      READ(6,*) YU(CHBDC-NAXLE)
      ELSEIF(CHBDC.GE.(NAXLE+NLINES+1).AND.CHBDC.LE.(NAXLE+NLINES+NAXLE
     1)) THEN
      WRITE(6,1233) (CHBDC-NAXLE-NLINES)
 1233 FORMAT(/16X,'WU(',I2,') = ')
      READ(6,*) WU(CHBDC-NAXLE-NLINES)
      ELSE
      WRITE(6,*) 'Out of boundary, PLEASE re-input'
      GOTO 102
      ENDIF
      GOTO 102
      ENDIF
!
 140  CONTINUE
      WRITE(6,*)
      WRITE(6,820)
      WRITE(6,1000)
      WRITE(6,1010)
      WRITE(6,1020) YMIN,BS
      WRITE(6,1030) WALLD,NLOAD
      WRITE(6,1040) WALLW,NX
      WRITE(6,1050) CONCT,NDES
      WRITE(6,1060) WEART,EDGE
      WRITE(6,1061) BMRAIL
      WRITE(6,820)
      WRITE(6,1150)
 141  CONTINUE
      READ(6,*) UNFIX
      IF(UNFIX.EQ.99) THEN
      WRITE(6,*) 'THIS PART IS COMPLETE, THANK YOU'
      WRITE(6,*)
      GOTO 200
      ELSEIF(UNFIX.EQ.1) THEN
      WRITE(6,1201)
      READ(6,*) YMIN
      ELSEIF(UNFIX.EQ.2) THEN
      WRITE(6,1202)
      READ(6,*) WALLD
      ELSEIF(UNFIX.EQ.3) THEN
      WRITE(6,1203)
      READ(6,*) WALLW
      ELSEIF(UNFIX.EQ.4) THEN
      WRITE(6,1204)
      READ(6,*) CONCT
      ELSEIF(UNFIX.EQ.5) THEN
      WRITE(6,1205)
      READ(6,*) WEART
      ELSEIF(UNFIX.EQ.6) THEN
      WRITE(6,1206)
      READ(6,*) BMRAIL
      ELSEIF(UNFIX.EQ.7) THEN
      WRITE(6,1207)
      READ(6,*) BS
      ELSEIF(UNFIX.EQ.8) THEN
      WRITE(6,1208)
      READ(6,*) NLOAD
      IF(NLOAD.EQ.2) THEN
      WRITE(6,1220)
      READ(6,*) CSAW
      ENDIF
      ELSEIF(UNFIX.EQ.9) THEN
      WRITE(6,1209)
      READ(6,*) NX
      IF(NX.EQ.2) THEN
      WRITE(6,1230)
      READ(6,*) XVAL
      ENDIF
      ELSEIF(UNFIX.EQ.10) THEN
      WRITE(6,1210)
      READ(6,*) NDES
      ELSEIF(UNFIX.EQ.11) THEN
      WRITE(6,1211)
      READ(6,*) EDGE
      ELSE
      WRITE(6,*) 'Out of boundary, PLEASE re-input'
      GOTO 141
      ENDIF
      WRITE(6,1160)
      GOTO 140
!
 200  CONTINUE
      WRITE(6,1090)
      READ(6,*) NCASE
      WRITE(70,*) NCASE
      WRITE(70,*) YMIN,WALLD,WALLW,CONCT,WEART,BMRAIL,
     1BS,NLOAD,NX,NDES,EDGE      
!***  CONDITIONAL  06 JUNE, 2006 YOGENDRA NATH*************************
      IF(NDES.EQ.1) THEN
      WRITE(70,*) ALPLL,ALPDL1,ALPDL2,ALPDL3,DLA,PHIS,PHIC,RHOMIN,FY,FC
      ENDIF
      
      IF(FIX8.EQ.4) WRITE(70,*) NAXLE,NLINES,(XU(I),I=1,NAXLE),(YU(I),I
     1=1,NLINES),(WU(I),I=1,NAXLE)
!
      I=1
 100  CONTINUE
      IF(I.LE.NCASE) THEN
      WRITE(6,1100) I
      READ(6,101) TITLE
 101  FORMAT(A)
      WRITE(6,1110)
      READ(6,*) S
      WRITE(6,1111)
      READ(6,*) SC
      WRITE(6,1112)
      READ(6,*) TRATIO
      IF(FIX8.EQ.2.AND.FIX9.NE.2) THEN
      WRITE(6,1113)
      READ(6,*) CSAW
      ENDIF
      IF(FIX8.EQ.1.AND.FIX9.EQ.2) THEN
      WRITE(6,1114)
      READ(6,*) XVAL
      ENDIF
      IF(FIX8.EQ.2.AND.FIX9.EQ.2) THEN
      WRITE(6,1113)
      READ(6,*) CSAW
      WRITE(6,1114)
      READ(6,*) XVAL
      ENDIF
      IF(FIX8.EQ.3.AND.FIX9.EQ.2) THEN
      WRITE(6,1114)
      READ(6,*) XVAL
      ENDIF
      IF(FIX8.EQ.4.AND.FIX9.EQ.2) THEN
      WRITE(6,1114)
      READ(6,*) XVAL
      ENDIF
      WRITE(70,*) TITLE
      WRITE(70,*) Sc,S,TRATIO
      IF(FIX8.EQ.2) WRITE(70,*) CSAW
      IF(FIX9.EQ.2) WRITE(70,*) XVAL
      I=I+1
      GOTO 100
      ENDIF
      WRITE(6,*) 'WHAT TYPE OF SOLUTION? (N) UMERICAL / (M) ATHES FORM '
      READ(6,1) SOLU
 1    FORMAT(A)
      WRITE(70,1) SOLU
!
!     END OF STORE INPUT FILE
!
      CLOSE(70)
!
!     FORMAT
!
 700  FORMAT(/15X,'***************************************************'
     1      ,/15X,'*                                                 *'
     1      ,/15X,'*                WELCOME TO INPUT3                *'
     1      ,/15X,'*                                                 *'
     1      ,/15X,'*   A PROGRAM HELPS YOU TO CREATE AN INPUT FILE   *'
     1      ,/15X,'*             FOR THE PROGRAM ANDECAS3            *'
     1      ,/15X,'*                                                 *'
     1      ,/15X,'***************************************************'
     1      )
 710  FORMAT(//15X,' There are four parts in INPUT3:'                  
     1       //20X,'I    Parameters'                                   
     1        /20X,'II   General data for all cases',                  
     1        /20X,'III  The data for USER DEFINED LOAD'               
     1        /20X,'IV   Specific data for each case')
 720  FORMAT(//5X,'INPUT3 needs a name for the new file that has to be 
     1 equal to 4 letters only',                                
     1       //5X,'WARNING: If a file already exits under that nmae, it
     1will be erased.',                                                
     1        /14X,'It will be saved in the current directory.')
 730  FORMAT(/5X,'What is the name of the NEW file => ')
 740  FORMAT(8A)
 750  FORMAT(///8X,'----------> Input for : ',A,' <----------')
 760  FORMAT(//3X,'I) Parameters: {TYPE a number, THEN press ENTRE.}'//)
 770  FORMAT(/16X,'Alpha Live load   = ')
 771  FORMAT(/16X,'Alpha Dead load 1 = ')
 772  FORMAT(/16X,'Alpha Dead load 2 = ')
 773  FORMAT(/16X,'Alpha Dead load 3 = ')
 774  FORMAT(/16X,'DLA               = ')
 775  FORMAT(/16X,'Phi Steel         = ')
 776  FORMAT(/16X,'Phi Concrete      = ')
 777  FORMAT(/16X,'Min. ratio As/bh  = ')
 778  FORMAT(/16X,'fy                = ')
 779  FORMAT(/16X,'fc                = ')
 780  FORMAT(//2X,'II) General data: {TYPE a number, THEN press ENTRE}'
     1//)
 790  FORMAT(/18X,'Min. wheel distance Y min (m)     = ')
 791  FORMAT(/18X,'Barrier wall distance (m)         = ')
 792  FORMAT(/18X,'Weight of the wall (kN/m)         = ')
 793  FORMAT(/18X,'Thickness of concrete slab (m)    = ')
 794  FORMAT(/18X,'Wearing surface thickness (m)     = ')
 795  FORMAT(/18X,'Moment due to rail load (kNm/m)   = ')
 796  FORMAT(/18X,'Bar spacing (m)                   = ')
 797  FORMAT(/2X,'Loads (1 for OHBDC, 2 for CSA, 3 for CHBDC AND 4 for 
     1USER DEFINED )  = ')
 798  FORMAT(/18X,'Type of analysis (1 or 2)         = ')
 799  FORMAT(/18X,'Design (1 for Yes, 2 for No)      = ')
 800  FORMAT(/18X,'Edge (1 for stiffness, 2 for unstiffness)    = ')
 801  FORMAT(//2X,'III) The data for USER DEFINED LOADS: {TYPE a number
     1, THEN press ENTRE.}'//)
 820  FORMAT(' ########################################################
     1#######################')
 830  FORMAT(' #                                  PARAMETERS           
     1                      #')
 840  FORMAT(' #                                  ----------           
     1                      #')
 850  FORMAT(' #         ALPHA L     =',F8.3,'                PHI steel
     1    =',F8.3,'         #')
 860  FORMAT(' #         ALPHA D1    =',F8.3,'                PHI concr
     1ete =',F8.3,'         #')
 870  FORMAT(' #         ALPHA D2    =',F8.3,'                RHO minim
     1um  =',F8.3,'         #')
 880  FORMAT(' #         ALPHA D3    =',F8.3,'                fy steel 
     1    =',F8.3,'  MPa    #')
 890  FORMAT(' #         DLA         =',F8.3,'                f''c conc
     1rete =',F8.3,' MPa     #')
 1000 FORMAT(' #                                 GENERAL DATA          
     1                      #')
 1010 FORMAT(' #                                 ------------          
     1                      #')
 1020 FORMAT(' #   1. Y min          =',F8.3,' m','          7. Bar spa1
     1cing   =',F8.3,' m','       #')
 1030 FORMAT(' #   2. Wall distance  =',F8.3,' m','          8. Loading
     1 case  =',I3,'              #')
 1040 FORMAT(' #   3. Wall weight    =',F8.3,' kN/m','       9. Analysi
     1s type =',I3,'              #')
 1050 FORMAT(' #   4. Conc. thick.   =',F8.3,' m','         10. Design 
     1option =',I3,'              #')
 1060 FORMAT(' #   5. Wearing thick. =',F8.3,' m','         11. Edge ty
     1pe     =',I3,'              #')
 1061 FORMAT(' #   6. Rail moment    =',F8.3,' kNm','                  
     1                         #')
 1065 FORMAT(' #                         DATA FOR USER DEFINED LOADS   
     1                      #')
 1070 FORMAT(' #                         ___________________________   
     1                      #')
 1090 FORMAT(//2X,'How many cases do you want to analyze ? ')
 1100 FORMAT(5X,'CASE #',I5,'  => TITLE = ')
 1110 FORMAT(/22X,'S     (m)      = ')
 1111 FORMAT(/22X,'Sc    (m)      = ')
 1112 FORMAT(/22X,'t2/t1          = ')
 1113 FORMAT(/22X,'CSAW Load (kN) = ')
 1114 FORMAT(/22X,'x     (m)      = ')
 1150 FORMAT(2X,'Any changes from General Data ? (1 to 11, 99 = No) => 
     1')
 1155 FORMAT(2X,'Any changes from the Data for USER DEFINED LOADS ? (1 
     1to ',I2,', 99 = No)  => ')
 1160 FORMAT(1X,'More changes from General Data ? (1 to 11, 99 = No) =>
     1 ')
 1165 FORMAT(1X,'More changes from the Data for USER DEFINED LOADS ? (1
     1to ',I2,', 99 = No) => ')
 1201 FORMAT(12X,'1. Y min          = ')
 1202 FORMAT(12X,'2. Wall distance  = ')
 1203 FORMAT(12X,'3. Wall weight    = ')
 1204 FORMAT(12X,'4. Conc. thick.   = ')
 1205 FORMAT(12X,'5. Wearing thick. = ')
 1206 FORMAT(12X,'6. Rail moment    = ')
 1207 FORMAT(12X,'7. Bar spacing    = ')
 1208 FORMAT(12X,'8. Loading case   = ')
 1209 FORMAT(12X,'9. Analysis type  = ')
 1210 FORMAT(11X,'10. Design option  = ')
 1211 FORMAT(11X,'11. Edge type      = ')
 1220 FORMAT(12X,'So CSA Load (kN)  = ')
 1230 FORMAT(12X,'       So  x (m)  = ')
 1300 FORMAT(//10X,'THANK YOU,',A,'IS NOW READY FOR ANDECAS4',//)
!
      STOP
      END