      PROGRAM ANDECAS4
!*****PROGRAM MODYANDECAS1 MODIFIED BY Y. NATH  30 MAY 2006*********
!*****BOTH ANALYSIS AND DESIGN CAN BE PERFORMED **************
!*****INPUT DATA ARE CONDITIONAL "NDES(1 or 2) (DESIGN OR ANALYSIS)***
!*****DATAFILE IS GENERATED ACCORDINGLY*******************************
!     PROGRAM FOR THE ANALYSIS AND DESIGN OF CANTILEVER SLAB OVERHANGS
!     OF SLAB-ON-GIRDER BRIDGES SUBJECTED TO THE OHBDC'91, CSA TRUCK,
!     CHBDC TRUCK AND USER DEFINED TRUCK. THE ANALYSIS IS DONE USING
!     THE SIMPLIFIED METHOD OF DR. MUFTI, BAKHT AND JAEGER (1993). THE
!     DESIGN IS PERFORMED FOLLOWING THE ONTARIO HIGHWAY BRIDGE AND
!     DESIGN CODE 1991.


      PARAMETER (MAXC1=15,pi=3.141592654)
      DIMENSION FNAME(10),BC(4,6,6,6),BI(4,5,11,6),BSC(2,6,6,6),
     *BSI(2,5,11,6),
     *SECT(40),SIZE(40,2),HC(11),RC(11),ACM(11),XCM(11),
     *MT(361),RI(11),AIM(11),XIM(11),NSECTC(11),NSECTI(11),CHOSEC(11,5),
     *CHOSEI(11,5),ASC(11),ASI(11),BB(maxc1),X(1000)

      INTEGER EDGE

      REAL MWALL,MWEAR,MCONC,MT,MMAX,MRAILR,MALLC,MGRAVC,MRAILC,MTX,
     *MRSUPP,MCONC1,MCONC3,MRAILI,MGRAVI,MALLI

      CHARACTER FNAME*1,FILINP*29,FILRES*29,FILOUT*29,SOLU*1,SECT*25,
     *CHOSEC*25,CHOSEI*25
      EXTERNAL fa,fb
      COMMON/A1/ A(3,5),P(3,5),XLINE(4)
      COMMON /C1/ SC,S,TRATIO,SRATIO,YMIN,NLOAD,CSAW,NX,XVAL,EDGE
      COMMON /C6/ PHIS,PHIC,B,RHOMIN,fy,fc
      COMMON /C7/ NSECTC,NSECTI,CHOSEC,CHOSEI
      COMMON /C8/ SIZE,SECT,COVR
      COMMON /D1/ xu(maxc1),yu(maxc1),wu(maxc1)
      COMMON /D2/ xx(maxc1),yline(maxc1),f(maxc1)
      COMMON /D3/ solu
      COMMON /D4/ bb,naxle,nline
      COMMON /D5/ yref
!     Design Coefficients are defined by Nath 
      ALPLL =1.0
      ALPDL1=0.0
      ALPDL2=0.0
      ALPDL3=0.0
      DLA   =0.0
      PHIS  =0.0
      PHIC  =0.0 
      RHOMIN=0.0
      FY    =0.0
      FC    =0.0
C     ECHO PRINT ON THE SCREEN
      WRITE(6,509)
      WRITE(6,500)
      READ(6,590) FNAME
      CALL NAME(FNAME,FILINP,FILRES,FILOUT)
      WRITE(6,502) FILINP
      WRITE(6,503) FILRES

      OPEN(71,FILE='DATA01.DAT',STATUS='OLD')
      OPEN(72,FILE='DATA02.DAT',STATUS='OLD')
      OPEN(73,FILE='DATA03.DAT',STATUS='OLD')
      OPEN(74,FILE='DATA04.DAT',STATUS='OLD')
      OPEN(79,FILE='SECTIONS.DAT',STATUS='OLD')

C     READ B COEFFICIENTS FOR CANTILEVER

      I5=71
      DO 10 I1=1,4
      DO 10 I2=1,6
      DO 10 I3=1,6
      READ(I5,506) BC(I1,I2,I3,1),BC(I1,I2,I3,2),BC(I1,I2,I3,3),
     *             BC(I1,I2,I3,4),BC(I1,I2,I3,5),BC(I1,I2,I3,6)
 10   CONTINUE

C     READ B COEFFICIENTS FOR INTERNAL PANEL

      I5=72
      DO 20 I1=1,4
      DO 20 I2=1,5
      DO 20 I3=1,11
      READ(I5,506) BI(I1,I2,I3,1),BI(I1,I2,I3,2),BI(I1,I2,I3,3),
     *           BI(I1,I2,I3,4),BI(I1,I2,I3,5),BI(I1,I2,I3,6)
 20   CONTINUE

C     READ B COEFFICIENTS FOR STIFFENED EDGE CANTILEVER

      I5=73
      DO 30 I1=1,2
      DO 30 I2=1,6
      DO 30 I3=1,6
      READ(I5,506) BSC(I1,I2,I3,1),BSC(I1,I2,I3,2),BSC(I1,I2,I3,3),
     *             BSC(I1,I2,I3,4),BSC(I1,I2,I3,5),BSC(I1,I2,I3,6)

 30   CONTINUE
c       write(*,*) bsc(1,6,6,1),bsc(1,6,6,2),bsc(1,6,6,3),
c     *             bsc(1,6,6,4),bsc(1,6,6,5),bsc(1,6,6,6)
C     READ B COEFFICIENTS FOR STIFFENED EDGE INTERNAL PANEL

      I5=74
      DO 40 I1=1,2
      DO 40 I2=1,5
      DO 40 I3=1,11
      READ(I5,506) BSI(I1,I2,I3,1),BSI(I1,I2,I3,2),BSI(I1,I2,I3,3),
     *             BSI(I1,I2,I3,4),BSI(I1,I2,I3,5),BSI(I1,I2,I3,6)
c      write(*,*) bsi(1)
 40   CONTINUE

C     READ SECTION SIZE

      DO 50 I=1,40
      READ(79,*) SIZE(I,1),SIZE(I,2),SECT(I)
 50   CONTINUE

      CLOSE(71)
      CLOSE(72)
      CLOSE(73)
      CLOSE(74)
      CLOSE(79)

C     READ INPUT DATA FROM A FNAME.DAT FILE

      OPEN(UNIT=70,FILE=FILINP,STATUS='OLD')
      OPEN(UNIT=80,FILE=FILRES,STATUS='UNKNOWN')
      READ(70,*) NCASE
C*****  Following read statements interchanged 06 JUNE, 06 by Yogendra ********
      READ(70,*) YMIN,WALLD,WALLW,CONCT,WEART,BMRAIL,COVR,NLOAD,NX,NDES,
     1EDGE

      IF(NDES.EQ.1) THEN
      READ(70,*) ALPLL,ALPDL1,ALPDL2,ALPDL3,DLA,PHIS,PHIC,RHOMIN,FY,FC
      ENDIF
!      READ(70,*) YMIN,WALLD,WALLW,CONCT,WEART,COVR,BMRAIL,NLOAD,NX,NDES,
!    *EDGE
C     ALL ABOUT VALUES CAN BE 0.0 EXCEPT NCASE, ALPLL,NLOAD,NX,NDES,EDGE

      IF(NLOAD.EQ.4) THEN
      READ(70,*) NAXLE,NLINES,(XU(I),I=1,NAXLE),(YU(I),I=1,NLINES),
     *(WU(I),I=1,NAXLE)
      ENDIF

C     NLOAD = 1 FOR OHBDC TRUCK MODEL;
C           = 2 FOR CSA TRUCK MODEL;
C           = 3 FOR CHBDC TRUCK MODEL.
C           = 4 FOR USER DEFINED TRUCK MODEL;
C     NX    = 1 CALCULATE THE MAXIMUM MOMENT INTENSITIES;
C           = 2 ANALYSIS FOR 1 SPECIFIC POINT.
C     NDES  = 1 FOR DESIGN REQUIRED;
C           = 2 FOR NO DESIGN.
C     EDGE  = 1 FOR EDGE STIFFENED SLAB;
C           = 2 FOR UNSTIFFENED EDGE SLAB.
C     SOLU  = 'N' or 'n' FOR NUMERICAL METHOD;
C           = 'M' or 'm' FOR MATHEMATICAL METHOD.

C     WRITE PROGRAM INTRODUCTION AND INPUT DATA IN .RES FILE
      WRITE(80,509)
      WRITE(80,504)
!**** Following write is made comment on 20 May by Yoge** 
      IF(NDES.EQ.1)THEN
      WRITE(80,510)ALPLL,PHIS,ALPDL1,PHIC,ALPDL2,RHOMIN,ALPDL3,FY,DLA,
     1             FC
      ENDIF
      DO 280 I0 = 1,NCASE
      READ(70,590) TITLE
      READ(70,*) SC,S,TRATIO
      IF(NLOAD.EQ.2) READ(70,*) CSAW
      IF(NX.EQ.2) READ(70,*) XVAL
      READ(70,590) SOLU

C     DEFINE SRATIO
      SRATIO = S/SC

      WRITE(80,504)
      WRITE(80,505) TITLE
      WRITE(80,511) SC,S,TRATIO,YMIN,CONCT,WEART,WALLD,WALLW,BMRAIL
      IF (NLOAD.EQ.1) WRITE(80,512)
      IF (NLOAD.EQ.2) WRITE(80,514) CSAW
      IF (NLOAD.EQ.3) WRITE(80,513)
      IF(NLOAD.EQ.4) THEN
      WRITE(80,*) NAXLE,NLINES
      WRITE(80,*) (XU(I),I=1,NAXLE),(YU(I),I=1,NLINES),(WU(I),I=1,NAXLE)
      ENDIF
      KONT = 0

      IF(NX.EQ.2) WRITE(80,517) XVAL
      IF(NX.EQ.1) WRITE(80,518)
!****** NDES = 2 is read through data now  on 06 June 06 by Yogendra*****
!        NDES=2
      IF(NDES.EQ.1) THEN
      WRITE(80,515)
      ELSE
      WRITE(80,516)
      ENDIF

      IF(EDGE.EQ.1) THEN
      WRITE(80,521)
      ELSE
      WRITE(80,522)
      ENDIF

      IF(TRATIO.LT.0.0) THEN
      WRITE(80,525)
      WRITE(6,525)
      KONT = KONT + 1
      ENDIF

      IF (TRATIO.GT.1.0) THEN
      WRITE(80,520)
      WRITE(6,520)
      KONT = KONT + 1
      ENDIF

      IF(SRATIO.GT.2.5) THEN
      WRITE(80,530)
      WRITE(6,530)
      KONT = KONT + 1
      ENDIF

      IF(YMIN.GT.SC) THEN
      WRITE(80,540)
      WRITE(6,540)
      KONT = KONT + 1
      ENDIF

      IF(KONT.GT.0) GO TO 280

      IF(NX.EQ.2) WRITE(80,*) XVAL

C     SLAB WIDTH

      B=1000.

C     DEFINE NAXLE AND NLINES - NO. OF AXLES AND NO. OF LINES OF LOADS

      IF(NLOAD.NE.4) NAXLE=5
      IF(NLOAD.NE.4) NLINES=4

C     DEFINE APPLIED LOADS

c      IF(NLOAD.EQ.4) THEN
c      DO 60 I=1,NAXLE
c      F(I)=WU(I)
c 60   CONTINUE
c      ELSEIF(NLOAD.EQ.2) THEN
c      DO 70 I=1,NAXLE
c      F(I)=CSAW*P(2,I)
c 70   CONTINUE
c      ELSE
c      DO 72 I=1,NAXLE
c      F(I)=P(NLOAD,I)
c 72   CONTINUE
c      ENDIF

C     DEFINE LOCATIONS OF LINES OF LOADS ALONG X

c      IF(NLOAD.NE.4) THEN
c      DO 75 I=1,NAXLE
c      YLINE(I)=A(NLOAD,I)
c 75   CONTINUE
c      ELSE
c      DO 80 I=1,NAXLE
c      YLINE(I)=XU(I)
c 80   CONTINUE
c      ENDIF

C     DEFINE LOCATIONS OF LINE OF LOADS ALONG Y

c      IF(NLOAD.NE.4) THEN
c      DO 90 I=1,NLINES
c      XX(I)=SC-YMIN-XLINE(I)
c 90   CONTINUE
c      ELSE
c      write(*,*) '*************',nlines
c      DO 95 I=1,NLINES
c      XX(I)=SC-YMIN-YU(I)
c      write(*,*) 'xx(i)=', xx(i), yu(i)

c 95   CONTINUE
c      ENDIF

      YWALL=SC-WALLD
      WEAR=WEART*23.5
      CONC=CONCT*24.

      IF(SOLU.EQ.'N'.OR.SOLU.EQ.'n') THEN
      WRITE(6,*) I0,' ANDECAS4 IS RUNNING NUMERICAL SOLUTION'
      WRITE(80,*) '    ANDECAS4 IS RUNNING NUMERICAL SOLUTION'
      OPEN(82,FILE=FILOUT,STATUS='UNKNOWN')
      WRITE(82,*)'       RC      MMAX    MWALL   MWEAR   MCONC   0.0
     * MRAILR    ACM     XCM  '

C     CALCULATE MAXIMUM MOMENT INTENSITIES AT 11 REFERENCE POINTS
C     IN THE CANTILEVER PANEL

      YDIV=SC*0.1
      YREF=SC+YDIV
      KC=1

      DO 100 I1=1,11
      MWALL=0.
      MWEAR=0.
      PART1=0.
      PART2=0.
      PART3=0.
      MCONC=0.
      YREF=YREF-YDIV
      RC(I1)=YREF
      THICK=CONCT*(TRATIO+(1.-TRATIO)*(SC-YREF)/SC)
      HC(I1)=1000.*THICK

      CALL PLACE(yref,nlines,nline,naxle)
      IF(NLINE.NE.0) THEN

      IF(NX.EQ.1) THEN
      CALL MOMENT(YREF,MT,KC,NLINE,NAXLE,BC,BI,BSC,BSI)
      CALL MAX(MT,MMAX,XMMAX)
      ENDIF

      ENDIF

      IF(NLINE.EQ.0) THEN
      MMAX=0.
      XMMAX=0.
      ENDIF

      IF(NX.EQ.2) THEN
      CALL MOMENX(YREF,MTX,KC,NAXLE,NLINE,BC,BI,BSC,BSI)
      MMAX=MTX
      XMMAX=XVAL
      ENDIF

      IF(I1.EQ.11) THEN
      Y1MAX = MMAX
      X1MAX = XMMAX
      ENDIF

      X1=YREF+WALLD

      IF(X1.GT.SC) THEN
      MRAILR=0.
      ELSE
      XRAIL=SC-X1
      IF(WALLW.EQ.0) MRAILR=BMRAIL/(0.8*XRAIL+1.15)
      IF(WALLW.NE.0) MRAILR=BMRAIL/(0.8*XRAIL+1.5)
      ENDIF

      IF(I1.EQ.11) MRSUPP=MRAILR

      IF(YREF.LT.YWALL) THEN
      MWALL=WALLW*(YWALL-YREF)
      ELSE
      MWALL=0.
      ENDIF

      MWEAR=WEAR*(SC-YREF)*(SC-YREF)*0.5
      PART1=(SC-YREF)*(SC-YREF)
      PART2=(1.-TRATIO)
      PART3=(0.5*YREF/SC)+(1-YREF/SC)/3.
      MCONC=CONC*PART1*(0.5-PART2*PART3)
! *** DESIGN COEFFS DEFINED  06 JUNE 06 by Nath ********
      MALLC=ALPDL1*MWALL+ALPDL2*MWEAR+ALPDL1*MCONC
      MGRAVC=ALPLL*(1+DLA)*MMAX+MALLC
      MRAILC=ALPLL*MRAILR+MALLC

      IF(MGRAVC.GE.MRAILC) THEN
      ACM(I1)=MGRAVC
      XCM(I1)=XMMAX
      ELSE
      ACM(I1)=MRAILC
      XCM(I1)=99.
      ENDIF

C     WRITE RESULTS IN FILENAME.OUT
      WRITE(82,670) RC(I1),MMAX,MWALL,MWEAR,MCONC,0.0,MRAILR,ACM(I1),
     *XCM(I1)
 100   CONTINUE

      IF(SRATIO.LE.0.1) GOTO 105

C     CALCULATE MAXIMUM MOMENT INTENSITIES AT 11 REF. POINTS
C     IN THE INTERNAL PANEL

      YDIV=S*0.1
      YREF= -YDIV
      KC=2

      DO 110 I2=1,11
      MWALL=0.
      MWEAR=0.
      MCONC1=0.
      MCONC3=0.
      YREF=YREF+YDIV
      RI(I2)=YREF

      IF(NX.EQ.1) THEN
      CALL MOMENT(YREF,MT,KC,NLINE,NAXLE,BC,BI,BSC,BSI)
      CALL MAX(MT,MMAX,XMMAX)
      ENDIF

      IF(NX.EQ.2) THEN
      CALL MOMENX(YREF,MTX,KC,NAXLE,NLINE,BC,BI,BSC,BSI)
      MMAX=MTX
      XMMAX=XVAL
      ENDIF

      IF(I2.EQ.1) THEN
      Y2MAX = MMAX
      X2MAX = XMMAX
      ELSE
      GOTO 109
      ENDIF

      IF(Y1MAX.NE.Y2MAX) THEN
      Y2MAX = Y1MAX
      X2MAX = X1MAX
      ENDIF

      IF(I2.EQ.1) THEN
      MMAX = Y2MAX
      XMMAX = X2MAX
      ENDIF

  109 IF(I2.EQ.11) MMAX=0.

      MRAILR=MRSUPP-(MRSUPP*YREF/S)
      MWALL=WALLW*(YREF+YWALL-(YREF*(S+YWALL)/S))
      MWEAR=WEAR*(SC*SC-S*YREF)*(S-YREF)/(2.*S)
      MCONC1=CONC*(SC*SC*(1.+2*TRATIO)/6.)*(1.-YREF/S)
      MCONC3=CONC*(YREF-S)*(YREF*0.5)
!***  DESIGN COEFF ARE DEFINED ON 06 JUNE 06 Nath
      MALLI=ALPDL1*MWALL+ALPDL2*MWEAR+ALPDL1*MCONC1+ALPDL3*MCONC3
      MGRAVI=ALPLL*(1.+DLA)*MMAX+MALLI
      MRAILI=ALPLL*MRAILR+MALLI

      IF(MGRAVI.GE.MRAILI) THEN
      AIM(I2)=MGRAVI
      XIM(I2)=XMMAX
      ELSE
      AIM(I2)=MRAILI
      XIM(I2)=99.
      ENDIF

C     WRITE RESULTS IN FILENAME.OUT

      WRITE(82,670) RI(I2),MMAX,MWALL,MWEAR,MCONC1,MCONC3,MRAILR,AIM(I2)
     *,XIM(I2)
 110  CONTINUE

C     END OF NUMERICAL METHOD CALCULATION
      ENDIF

      IF(SOLU.EQ.'M'.OR.SOLU.EQ.'m') THEN
      WRITE(6,*) I0,' ANDECAS4 IS RUNNING MATHMATICAL FORM SOLUTION'
      WRITE(80,*) '    ANDECAS4 IS RUNNING MATHMATICAL FORM SOLUTION'
      OPEN(82,FILE=FILOUT,STATUS='UNKNOWN')
      WRITE(82,*)'       RC      MMAX    MWALL   MWEAR   MCONC   0.0
     * MRAILR    ACM     XCM  '

C     CALCULATE MAXIMUM MOMENT INTENSITIES AT 11 REF. POINTS
C     IN THE CANTILEVER PANEL

      YDIV=SC*0.1
      YREF=SC + YDIV
      KC = 1

      DO 150 I1=1,11
      MWALL=0.
      MWEAR=0.
      MCONC=0.
      YMAX=0.
      XMAX=0.
      YREF=YREF-YDIV
      RC(I1)=YREF
      THICK=CONCT*(TRATIO+(1.-TRATIO)*(SC-YREF)/SC)
      HC(I1)=1000.*THICK
      CALL PLACE(yref,nlines,nline,naxle)
c      write(*,*) 'nlines=',nlines,'nline=',nline

      IF(NLINE.NE.0) THEN
      DO 120 I=1,NLINE
      YRC=YREF/SC
      C=XX(I)
      CR=C/SC

      IF(EDGE.EQ.1) THEN
      CALL BSCAN(BSC,TRATIO,SRATIO,YRC,CR,BK)
      ELSE
      CALL BCAN(BC,TRATIO,SRATIO,YRC,CR,BK)
      ENDIF

      BB(I)=BK
 120  CONTINUE
c      write(*,*) 'bb(',i1,')=',bk

      IF(BK.EQ.0) THEN
      YMOM=0.
      ELSEIF(c.EQ.YREF) THEN
      YMOM=0.
      ELSEIF(NX.EQ.1) THEN
      CALL DHRT1(0.,yline(naxle),0.25,1e-3,x,40*nline,m,KC)
      DO 140 ii=1,m
      ymom=0.
      ymoma=0.
      ymomb=0.
      DO 130 i=1,nline
      DO 130 j=1,naxle
      ymom=ymom+2*f(j)*bb(i)*(xx(i)-yref)**4/pi/((xx(i)-yref)**2+
     *bb(i)**2*(yline(j)-x(ii))**2)**2
      ymoma=ymoma+2*f(j)*bb(i)*(xx(i)-yref)**4/pi/((xx(i)-yref)**2+
     *bb(i)**2*yline(j)**2)**2
      ymomb=ymomb+2*f(j)*bb(i)*(xx(i)-yref)**4/pi/((xx(i)-yref)**2+
     *bb(i)**2*(yline(j)-yline(naxle))**2)**2
 130  CONTINUE

      IF(ii.EQ.1) THEN
      xmax=X(ii)
      ymax=ymom
      ENDIF

      IF(ymomb.gt.ymax) THEN
      ymax=ymomb
      xmax=YLINE(NAXLE)
      ENDIF

      IF(ymoma.gt.ymax) THEN
      ymax=ymoma
      xmax=0.0
      ENDIF

      IF(ymom.gt.ymax) THEN
      ymax=ymom
      xmax=X(ii)
      ENDIF

 140  CONTINUE
      ENDIF
      ENDIF

      IF(NLINE.EQ.0) THEN
      YMAX=0.
      XMAX=0.
      ENDIF

      IF(NX.EQ.2) THEN
      CALL MOMENX(YREF,MTX,KC,NAXLE,NLINE,BC,BI,BSC,BSI)
      YMAX = MTX
      XMAX = XVAL
      ENDIF

      IF(I1.EQ.11) THEN
      Y1MAX=YMAX
      X1MAX=XMAX
      ENDIF

      X1=YREF+WALLD

      IF(X1.GT.SC) THEN
      MRAILR=0.
      ELSE
      XRAIL=SC-X1
      IF(WALLW.EQ.0) MRAILR=BMRAIL/(0.8*XRAIL+1.15)
      IF(WALLW.NE.0) MRAILR=BMRAIL/(0.8*XRAIL+1.5)
      ENDIF

      IF(I1.EQ.11) MRSUPP=MRAILR
      IF(YREF.LT.YWALL) THEN
      MWALL=WALLW*(YWALL-YREF)
      ELSE
      MWALL=0.
      ENDIF

      MWEAR=WEAR*(SC-YREF)*(SC-YREF)*0.5
      PART1=(SC-YREF)*(SC-YREF)
      PART2=(1.-TRATIO)
      PART3=(0.5*YREF/SC)+(1.-YREF/SC)/3.
      MCONC=CONC*PART1*(0.5-PART2*PART3)
c***  DESIGN COEFFS ARE DEFINED 06 JUNE 06   by Ynath till Endif     
      MALLC=ALPDL1*MWALL+ALPDL2*MWEAR+ALPDL1*MCONC
      MGRAVC=ALPLL*(1.+DLA)*YMAX+MALLC
      MRAILC=ALPLL*MRAILR+MALLC

      IF(MGRAVC.GE.MRAILC) THEN
 
      ACM(I1)=MGRAVC
      XCM(I1)=XMAX
      ELSE
      ACM(I1)=MRAILC
      XCM(I1)=99.
      ENDIF

C     WRITE RESULTS IN FILENAME.OUT

      WRITE(82,670) RC(I1),YMAX,MWALL,MWEAR,MCONC,0.,MRAILR,ACM(I1),
     *XCM(I1)


 150  CONTINUE

      IF(SRATIO.LE.0.1) GOTO 105

C     CALCULATE MAXIMUM MOMENT INTENSITIES AT 11 REF. POINTS
C     IN INTENAL PANAL

      YDIV=S*0.1
      YREF=-YDIV
      KC = 2

      DO 190 I2=1,11
      MWALL=0.
      MWEAR=0.
      MCONC1=0.
      MCONC3=0.
      YREF=YREF+YDIV
      RI(I2)=YREF

      IF(I2.EQ.11) THEN
      YMAX=0.
      XMAX=0.
      ENDIF

      IF(I2.EQ.11) GOTO 185

      DO 160 I=1,NLINE
      YRI=YREF/S
      C=XX(I)
      CR=C/SC

      IF(EDGE.EQ.1) THEN
      CALL BSINT(BSI,TRATIO,SRATIO,YRI,CR,BK)
      ELSE
      CALL BINT(BI,TRATIO,SRATIO,YRI,CR,BK)
      ENDIF

      BB(I) = BK
 160  CONTINUE
C      write(*,*) 'bb(',i2,')=',bk
      IF(BK.EQ.0) THEN
      YMOM=0.
      ELSEIF(NX.EQ.1) THEN
      CALL DHRT1(0.,YLINE(NAXLE),0.25,1E-3,X,40*NLINE,M,KC)
      DO 180 II=1,M
      ymom=0.
      ymoma=0.
      ymomb=0.
      DO 170 I = 1,NLINE
      DO 170 J = 1,NAXLE
      YMOM = YMOM +2*f(j)*bb(i)*(xx(i)**4)*((s-yref)**4)/pi/(xx(i)**2
     * *((s-yref)**2)+(s**2)*(bb(i)**2)*(yline(j)-X(ii))**2)**2
      YMOMA = YMOMA +2*f(j)*bb(i)*xx(i)**4*(s-yref)**4/pi/(xx(i)**2
     * *(s-yref)**2+s**2*bb(i)**2*yline(j)**2)**2
      YMOMB = YMOMB +2*f(j)*bb(i)*xx(i)**4*(s-yref)**4/pi/(xx(i)**2
     * *(s-yref)**2+s**2*bb(i)**2*(yline(j)-yline(naxle))**2)**2
 170  CONTINUE

      IF(II.EQ.1) THEN
      XMAX = X(ii)
      YMAX = YMOM
      ENDIF

      IF(ymomb.gt.ymax) THEN
      ymax=ymomb
      xmax=YLINE(NAXLE)
      ENDIF

      IF(ymoma.gt.ymax) THEN
      ymax=ymoma
      xmax=0.0
      ENDIF

      IF(YMOM.GT.YMAX) THEN
      YMAX = YMOM
      XMAX = X(ii)
      ENDIF

 180  CONTINUE
      ENDIF

      IF(NX.EQ.2) THEN
      CALL MOMENX(YREF,MTX,KC,NAXLE,NLINE,BC,BI,BSC,BSI)
      YMAX = MTX
      XMAX = XVAL
      ENDIF

      IF(I2.EQ.1) THEN
      Y2MAX = YMAX
      X2MAX = XMAX
      ELSE
      GOTO 185
      ENDIF

      IF(Y1MAX.NE.Y2MAX)  THEN
      Y2MAX = Y1MAX
      X2MAX = X1MAX
      ENDIF

      IF(I2.EQ.1) THEN
      YMAX=Y2MAX
      XMAX=X2MAX
      ENDIF

 185  MRAILR=MRSUPP-(MRSUPP*YREF/S)
      MWALL=WALLW*(YREF+YWALL-(YREF*(S+YWALL)/S))
      MWEAR=WEAR*(SC*SC-S*YREF)*(S-YREF)/(2.*S)
      MCONC1=CONC*(SC*SC*(1.+2*TRATIO)/6.)*(1.-YREF/S)
      MCONC3=CONC*(YREF-S)*(YREF*0.5)
c     DESIGN COEFFS ARE REDEFINED 06 JUNE 06 by Ynath    
      MALLI=ALPDL1*MWALL+ALPDL2*MWEAR+ALPDL1*MCONC1+ALPDL3*MCONC3
      MGRAVI=ALPLL*(1.+DLA)*YMAX+MALLI
c
      MRAILI=ALPLL*MRAILR+MALLI

      IF(MGRAVI.GE.MRAILI) THEN
      AIM(I2)=MGRAVI
      XIM(I2)=XMAX
      ELSE
      AIM(I2)=MRAILI
      XIM(I2)=99.
      ENDIF

C     WRITE RESULT TO FILE.OUT

      WRITE(82,670) RI(I2),YMAX,MWALL,MWEAR,MCONC1,MCONC3,MRAILR,AIM(I2)
     *,XIM(I2)
 190  CONTINUE

c     END OF MATHMETICAL METHOD CACULATION
      ENDIF

 105  CONTINUE
C*****   NDES=2 is already  defined ln 167 on  20 May06  by Yogendra********
        
      IF(NDES.EQ.1) THEN
      CALL DECAS(HC,ACM,AIM,ASC,ASI)
      WRITE(80,550)
      DO 210 I3=1,11
      WRITE(80,560) RC(I3),XCM(I3),ACM(I3),NINT(ASC(I3)),CHOSEC(I3,1)

      IF(NSECTC(I3).GT.1) THEN
      DO 200 I4=2,NSECTC(I3)
      WRITE(80,580) CHOSEC(I3,I4)
 200  CONTINUE
      ENDIF

 210  CONTINUE
      IF(SRATIO.LE.0.1) THEN
      WRITE(80,504)
      GO TO 270
      ENDIF

      WRITE(80,570)
      DO 230 I5=1,11
      WRITE(80,560) RI(I5),XIM(I5),AIM(I5),NINT(ASI(I5)),CHOSEI(I5,1)

      IF(NSECTI(I5).GT.1) THEN
      DO 220 I6=2,NSECTI(I5)
      WRITE(80,580) CHOSEI(I5,I6)
 220  CONTINUE
      ENDIF

 230  CONTINUE
      WRITE(80,504)
      GOTO 270
      ELSE
      GOTO 240
 240  ENDIF

      WRITE(80,555)
      DO 250 I7=1,11
      WRITE(80,565) RC(I7),ACM(I7),XCM(I7)
 250  CONTINUE
      IF(SRATIO.LE.0.1) GO TO 265
      WRITE(80,575)
      DO 260 I8=1,11
      WRITE(80,565) RI(I8),AIM(I8),XIM(I8)
 260  CONTINUE
 265  CONTINUE
      WRITE(80,504)
 270  CONTINUE
 280  CONTINUE
      CLOSE(70)
      CLOSE(80)
      CLOSE(82)

C     END OF MAIN LOOP. FOLLOWING IS FORMAT

 500  FORMAT(/,' ENTER the name of the input file with NO extension => '
     *)
 502  FORMAT('   ANALYSIS ON ',A)
 503  FORMAT(/,'   RESULTS STORED IN ',A)
 504  FORMAT(//4X,'*****************************************************
     **********************')
 505  FORMAT(/4X,'CASE NAME :', 3X,A)
 506  FORMAT(6F10.3)
 509  FORMAT(/15X,'####################################################'
     *       /15X,'#             ***********************              #'
     *       /15X,'#             *** A N D E C A S 3 ***              #'
     *       /15X,'#             ***********************              #'
     *       /15X,'#                                                  #'
     *       /15X,'#      Analysis and design of cantilever slab      #'
     *       /15X,'#      overhangs  of  slab-on-girder  bridges      #'
     *       /15X,'#      subjected to  OHBDC 1991,   CSA truck,      #'
     *       /15X,'#      CHBDC  truck  and  USER DEFINED truck.      #'
     *       /15X,'#      The   analysis   is   done  using  the      #'
     *       /15X,'#      simplified  method of Dr. Mufti, Bakht      #'
     *       /15X,'#      Jaeger (1993). The design is performed      #'
     *       /15X,'#      following  the  Ontario  Highway   and      #'
     *       /15X,'#      Birdge Design Code 91.                      #'
     *       /15X,'####################################################'
     *       )
 510  FORMAT(/4X,'ALPHA LL  = ',F7.3,20X,'PHI STELL  = ',F7.3,
     *       /4X,'ALPHA DL1 = ',F7.3,20X,'PHI CONC.  = ',F7.3,
     *       /4X,'ALPHA DL2 = ',F7.3,20X,'RHO min.   = ',F7.3,
     *       /4X,'ALPHA DL3 = ',F7.3,20X,'fy  steel  = ',F9.3,'MPa',
     *       /4X,'DLA       = ',F7.3,20X,'f''c conc. = ',F7.3,'MPa')
 511  FORMAT(/4X,'Cantilever span, Sc                = ',F7.3,'m',
     *       /4X,'Girder spacing,  S                 = ',F7.3,'m',
     *       /4X,'Thickness ratio, t2/t1             = ',F7.3,
     *       /4X,'Min. load distance from free edge  = ',F7.3,'m',
     *       /4X,'Concrete thickness                 = ',F7.3,'m',
     *       /4X,'Wearing surface thickness          = ',F7.3,'m',
     *       /4X,'Wall distance from free edge       = ',F7.3,'m',
     *       /4X,'Weight of the wall                 = ',F7.3,'KN/m',
     *       /4X,'Bending moment due to railing load = ',F7.3,'KNm')
 512  FORMAT(/4X,'Analysis required for OHBDC truck ')
 513  FORMAT(/4X,'Analysis required for CHBDC truck ')
 514  FORMAT(/4X,'Analysis required for FOR CSA truck, W=',F8.3,'KN')
 515  FORMAT(/4X,'Design required')
 516  FORMAT(/4X,'Design NOT required')
 517  FORMAT(/4X,'Analysis required for x ',F6.3,' m')
 518  FORMAT(/4X,'Analysis required to determine maximum intensities')
 520  FORMAT(/4X,'Thickness ratio t2/t1 is greater than 1.0',//)
 521  FORMAT(/4X,'The slab has edge stiffening ',//)
 522  FORMAT(/4X,'The slab has no edge stiffening ',//)
 525  FORMAT(/4X,'Thickness ratio t2/t1 is less than 0.0',//)
 530  FORMAT(/4X,'Internal panel span,s,is greater than 2.5Sc',//)
 540  FORMAT(/4X,'Min. load dist. is greater than cant. span Sc',//)
 550  FORMAT(//4X,'CANTILEVER panel:'
     *       //7X,'Yc',10X,'X',9X,'Mom. int.',4X,'Steel area',8X,
     *       'Proposed',/7X,'(m)',8X,'(m)',9X,'(kNm/m)',7X,'(mm2/m)',
     *       10X,'design')
 555  FORMAT(//5X,'Cantilever:',
     *         5X,'Yc(m)',3X,'Moment intensity(kNm/m)',5X,'X(m)')
 560  FORMAT(/3X,F8.3,3X,F8.3,6X,F9.3,6X,I7,10X,A)
 565  FORMAT(/16X,F10.3,7X,F10.3,10X,F10.3)
 570  FORMAT(//4X,'INTERNAL panel:'
     *       //7X,'Yi',10X,'X',9X,'Mom. int.', 4X,'Steel area',8X,
     *       'Proposed',/7X,'(m)',8X,'(m)',9X,'(kNm/m)',7X,'(mm2/m)',
     *       10X,'design')
 575  FORMAT(//5X,'Internal panel:','Yi(m)',
     *         3X,'Moment intensity (kNm/m)',5X,'X(m)')
 580  FORMAT(58X,'or',A)
 590  FORMAT(10A)
 610  FORMAT(//,3F7.3)
 670  FORMAT(7X,F5.3,6F8.3,F10.3,F7.2)

      STOP
      END

      SUBROUTINE NAME(NAM,NAMINP,NAMRES,NAMOUT)

C     THIS IS A CHARACTER MANIPULATION SUBROUTINE WHICH ERASE ALL BLANKS
C     FROM THE ORIGINAL FILENAME STORED IN A VECTOR NAM AND CREATE THREE
C     FILENMAES STORED IN THREE VARIBLES NAMINP, NAMRES AND NAMOUT

C     DEFINITION

C     NAM - FILENAME WITHOUT EXTENSION
C     EXTINP - EXTENSION FOR INPUT FILE
C     EXTRES - EXTENSION FOR RESULTING FILE
C     EXTOUT - EXTENSION FOR OUTPUT FILE
C     NAMINP - INPUT FILENAME WITH EXTENSION
C     NAMRES - RESULTING FILENAME WITH EXTENSION
C     NAMOUT - OUTPUT FILENAME WITH EXTENSION

      DIMENSION NAM(10)
      CHARACTER*1 NAM
      CHARACTER*4 EXTINP,EXTRES,EXTOUT
      CHARACTER*29 NAMINP,NAMRES,NAMOUT

      EXTINP='.DAT'
      EXTRES='.RES'
      EXTOUT='.OUT'
      I1=0
      DO 10 I=1,10
      IF(I1.EQ.0) THEN
      IF(NAM(I).NE.' ') I1=I
      ELSE
      IF((NAM(I).EQ.' ') .OR. (I.EQ.(I1*8))) GO TO 20
      ENDIF
 10   CONTINUE
 20   CONTINUE
      I2=I-1
      WRITE(NAMINP,100) (NAM(I),I=I1,I2),EXTINP
      WRITE(NAMRES,100) (NAM(I),I=I1,I2),EXTRES
      WRITE(NAMOUT,100) (NAM(I),I=I1,I2),EXTOUT
 100  FORMAT(9A)
      RETURN
      END

      BLOCK DATA

      COMMON/C2/ BC1(4),BC2(6),BC3(6),BC4(6)
      COMMON/C3/ BI1(4),BI2(5),BI3(11),BI4(6)
      COMMON/C9/ BSC1(2),BSC2(6),BSC3(6),BSC4(6)
      COMMON/C10/ BSI1(2),BSI2(5),BSI3(11),BSI4(6)
      COMMON/A1/ A(3,5),P(3,5),xline(4)

      DATA BC1(1)/1.0/, BC1(2)/0.5/, BC1(3)/0.333/, BC1(4)/0.0/,
     *     BC2(1)/2.5/, BC2(2)/2.0/, BC2(3)/1.5/, BC2(4)/1.0/,
     *     BC2(5)/0.5/, BC2(6)/0.0/, BC3(1)/1.0/, BC3(2)/0.8/,
     *     BC3(3)/0.6/, BC3(4)/0.4/, BC3(5)/0.2/, BC3(6)/0.0/,
     *     BC4(1)/1.0/, BC4(2)/0.8/, BC4(3)/0.6/, BC4(4)/0.4/,
     *     BC4(5)/0.2/, BC4(6)/0.0/

      DATA BSC1(1)/1.0/, BSC1(2)/0.5/, BSC2(1)/2.5/, BSC2(2)/2.0/,
     *     BSC2(3)/1.5/, BSC2(4)/1.0/, BSC2(5)/0.5/, BSC2(6)/0.0/,
     *     BSC3(1)/1.0/, BSC3(2)/0.8/, BSC3(3)/0.6/, BSC3(4)/0.4/,
     *     BSC3(5)/0.2/, BSC3(6)/0.0/, BSC4(1)/1.0/, BSC4(2)/0.8/,
     *     BSC4(3)/0.6/, BSC4(4)/0.4/, BSC4(5)/0.2/, BSC4(6)/0.0/

      DATA BI1(1)/1.0/, BI1(2)/0.5/, BI1(3)/0.333/, BI1(4)/0.0/,
     *     BI2(1)/2.5/, BI2(2)/2.0/, BI2(3)/1.5/, BI2(4)/1.0/,
     *     BI2(5)/0.5/, BI3(1)/0.0/, BI3(2)/0.1/, BI3(3)/0.2/,
     *     BI3(4)/0.3/, BI3(5)/0.4/, BI3(6)/0.5/, BI3(7)/0.6/,
     *     BI3(8)/0.7/, BI3(9)/0.8/, BI3(10)/0.9/, BI3(11)/1.0/,
     *     BI4(1)/1.0/, BI4(2)/0.8/, BI4(3)/0.6/, BI4(4)/0.4/,
     *     BI4(5)/0.2/, BI4(6)/0.0/

      DATA BSI1(1)/1.0/, BSI1(2)/0.5/, BSI2(1)/2.5/, BSI2(2)/2.0/,
     *     BSI2(3)/1.5/, BSI2(4)/1.0/, BSI2(5)/0.5/, BSI3(1)/0.0/,
     *     BSI3(2)/0.1/, BSI3(3)/0.2/, BSI3(4)/0.3/, BSI3(5)/0.4/,
     *     BSI3(6)/0.5/, BSI3(7)/0.6/, BSI3(8)/0.7/, BSI3(9)/0.8/,
     *     BSI3(10)/0.9/,BSI3(11)/1.0/,BSI4(1)/1.0/, BSI4(2)/0.8/,
     *     BSI4(3)/0.6/, BSI4(4)/0.4/, BSI4(5)/0.2/, BSI4(6)/0.0/

      DATA A(1,1),A(1,2),A(1,3),A(1,4),A(1,5)/0.,3.6,4.8,10.8,18./
      DATA A(2,1),A(2,2),A(2,3),A(2,4),A(2,5)/0.,4.0,10.,16.,0./
      DATA A(3,1),A(3,2),A(3,3),A(3,4),A(3,5)/0.,3.6,4.8,11.4,18./

      DATA P(1,1),P(1,2),P(1,3),P(1,4),P(1,5)/30.,80.,80.,100.,80./
      DATA P(2,1),P(2,2),P(2,3),P(2,4),P(2,5)/0.05,0.15,0.15,0.15,0./
      DATA P(3,1),P(3,2),P(3,3),P(3,4),P(3,5)/25.,62.5,62.5,87.5,75./

      DATA XLINE(1)/0./, XLINE(2)/1.8/, XLINE(3)/3./, XLINE(4)/4.8/

      END

      SUBROUTINE PLACE(yref,nlines,nline,naxle)

C     This subroutine places the relevent wheels of the OHBDC or CSA
C     or CHBDC truck or user defined truck on the cantilever with the
C     first row of wheels at a distance YMIN from the free edge and
C     determines the number of wheel lines,NLINE, needed to calculate
C     moments at YREF.

      PARAMETER (maxc1=15)
      INTEGER EDGE
      COMMON/A1/ A(3,5),P(3,5),xline(4)
      COMMON /C1/ SC,S,TRATIO,SRATIO,YMIN,NLOAD,CSAW,NX,XVAL,EDGE
      COMMON /D1/ xu(maxc1),yu(maxc1),wu(maxc1)
      COMMON /D2/ xx(maxc1),yline(maxc1),f(maxc1)
      nline=0
      DO 20 I1 = 1,NLINES
C      WRITE(*,*) 'NLINES=',NLINES
      IF(nload.eq.4) THEN
      xx(i1)=sc-YMIN-yu(i1)
      ELSE
      xx(i1)=sc-YMIN-xline(i1)
      ENDIF

c      write(*,*) 'xx(i1)=', xx(i1), 'yu(i1)=',yu(i1)
      IF(xx(i1).lt.yref) GOTO 30

      IF(NLOAD.EQ.4) THEN
      DO 60 I=1,NAXLE
      F(I)=WU(I)
 60   CONTINUE
      ELSEIF(NLOAD.EQ.2) THEN
      DO 70 I=1,NAXLE
      F(I)=CSAW*P(2,I)
 70   CONTINUE
      ELSE
      DO 72 I=1,NAXLE
      F(I)=P(NLOAD,I)
 72   CONTINUE
      ENDIF

C     DEFINE LOCATIONS OF LINES OF LOADS ALONG X

      IF(NLOAD.NE.4) THEN
      DO 75 I=1,NAXLE
      YLINE(I)=A(NLOAD,I)
 75   CONTINUE
      ELSE
      DO 80 I=1,NAXLE
      YLINE(I)=XU(I)
 80   CONTINUE
      ENDIF

C     DEFINE LOCATIONS OF LINE OF LOADS ALONG Y

c      IF(NLOAD.NE.4) THEN
c      DO 90 I=1,NLINES
c      XX(I)=SC-YMIN-XLINE(I)
c 90   CONTINUE
c      ELSE
c      write(*,*) '*************',nlines
c      DO 95 I=1,NLINES
c      XX(I)=SC-YMIN-YU(I)
c      write(*,*) 'xx(i)=', xx(i), yu(i)

c 95   CONTINUE
c      ENDIF

      nline=nline+1
c      write(*,*) 'nline=',nline, 'f(i)=',f(i), 'yline(i)=',yline(i),
c     * 'xx(i)=',xx(i)
 20   CONTINUE
 30   RETURN
      END

      SUBROUTINE MOMENT(YREF,MT,KC,NLINES,NAXLE,BC,BI,BSC,
     *BSI)

C     Given weights and coordindtes of NLINE of wheels, this subroutine
C     calculates moment intensities MT in the cantilever segment,or
C     internal panel at 361 points, 0.05m apart, at the specified
C     reference section YREF.

      PARAMETER (PI=3.141592654,MAXC1=15)
      DIMENSION MT(361),BC(4,6,6,6),BI(4,5,11,6),BSC(2,6,6,6),
     *BSI(2,5,11,6)
      INTEGER EDGE
      COMMON /C1/ SC,S,TRATIO,SRATIO,YMIN,NLOAD,CSAW,NX,XVAL,EDGE
      COMMON /d2/ xx(maxc1),yline(maxc1),f(maxc1)
      REAL MT,MY

C      IF(nload.ne.4.and.nload.ne.3) THEN
      XREF=-0.05
C      xcom=0.05
C      ELSE
C      xref=-yline(naxle)/360.
C      xcom=-xref
C      ENDIF

      Y=YREF
      IF(sratio.le.0.1) THEN
      yrc= y/sc
      ELSE
      YRC=Y/SC
      YRI=Y/S
      ENDIF

      DO 40 I1=1,361
      MT(I1)=0.
C      XREF=XREF+xcom
      XREF=XREF+ 0.05
      IF(NLOAD.EQ.1) THEN
      IF(I1.LT.69) GOTO 40
      IF(I1.GT.107 .AND. I1.LT.213) GOTO 40
      IF(I1.GT.221) GOTO 40
      ENDIF

      DO 30 I2=1,NAXLE
      X=XREF-YLINE(I2)
      DO 20 I3=1,NLINES
      C=XX(I3)
C      WRITE(*,*) 'C=',XX(I3)
      CR=C/SC

      IF(EDGE.EQ.1) THEN
      IF(KC.EQ.1) CALL BSCAN(BSC,TRATIO,SRATIO,YRC,CR,BK)
      IF(KC.EQ.2) CALL BSINT(BSI,TRATIO,SRATIO,YRI,CR,BK)
c
      ELSE
      IF(KC.EQ.1) CALL BCAN(BC,TRATIO,SRATIO,YRC,CR,BK)
      IF(KC.EQ.2) CALL BINT(BI,TRATIO,SRATIO,YRI,CR,BK)
c      write(*,*) 'bk=', bk,'YRI=',YRI,'CR=',CR
      ENDIF

      P=F(I2)
c      write(*,*) 'p=',p
      IF(BK.EQ.0.) MY=0.
      IF(BK.EQ.0.) GOTO 20
      IF(X.EQ.0.) MY=(2.*P*BK/PI)
      IF(X.EQ.0.) GOTO 20
      IF(KC.EQ.2) GOTO 10
      Q1=(2.*P*BK/PI)
      Q2=(C-Y)**4
      Q3=((C-Y)*(C-Y)+BK*BK*X*X)**2
      MY=Q1*Q2/Q3
      GOTO 20
 10   Q1=(2.*P*BK/PI)
      Q2=(C**4)*((S-Y)**4)
      Q3=(C*C*(S-Y)*(S-Y)+(S*BK*X)**2)**2
      MY=Q1*Q2/Q3
 20   MT(I1)=MT(I1)+MY
 30   CONTINUE
 40   CONTINUE
      RETURN
      END

      SUBROUTINE MAX(MT,MMAX,XMMAX)

C     Given values of moment intensity at 361 reference points, space
C     at 0.05m, this subroutine calculates the maximum intensity MMAX
C     and its location XMMAX.

      DIMENSION MT(361)
      REAL MT,MMAX

c      IF(NLOAD.EQ.4) THEN
c     COEFF=360./XU
c      ELSEIF(NLOAD.EQ.3) THEN
c      COEFF=22.5
c      ELSE
c      COEFF=20
c      ENDIF

      xcom=0.05
      MMAX=0.
      XMMAX=0.
      DO 10 I1 = 1,361

      IF(MT(I1).GT.MMAX) THEN
      MMAX = MT(I1)
      XMMAX = (I1*XCOM) - XCOM
      ENDIF

 10   CONTINUE

      RETURN
      END

      SUBROUTINE BCAN(BC,TRATIO,SRATIO,YR,CR,BK)

C     THIS SUBROUTINE FINDS THE VALUE OF B FOR THE CANTILEVER PORTION
C     FOR GIVEN VALUES OF TRATIO,SRATIO,YR AND CR

      DIMENSION A1(11),A2(11),A3(11),A4(11),B1(11),B2(11),B3(11),B4(11)
      DIMENSION BC(4,6,6,6)
      COMMON/C2/ BC1(4),BC2(6),BC3(6),BC4(6)

      DO 50 I1=1,4
      DO 40 I2=1,6
      BT=BC(I1,I2,1,1)
      DO 30 I3=1,6
      IF(I3.EQ.1) GOTO 20
      DO 10 I4=1,I3
      A4(I4)=BC4(I4)
      B4(I4)=BC(I1,I2,I3,I4)
 10   CONTINUE
      N4=I3
      CALL INTERP(A4,B4,N4,CR,BT)
      IF(BT.LT.0.) BT=0.
 20   CONTINUE
      A3(I3)=BC3(I3)
      B3(I3)=BT
 30   CONTINUE
      N3=6
      CALL INTERP(A3,B3,N3,YR,BT)
      IF(BT.LT.0.) BT=0.
      A2(I2)=BC2(I2)
      B2(I2)=BT
 40   CONTINUE
      N2=6
      CALL INTERP(A2,B2,N2,SRATIO,BT)
      IF(BT.LT.0.) BT=0.
      A1(I1)=BC1(I1)
      B1(I1)=BT
 50   CONTINUE
      N1=4
      CALL INTERP(A1,B1,N1,TRATIO,BT)
      IF(BT.LT.0.) BT=0.
      BK=BT
      RETURN
      END

      SUBROUTINE BSCAN(BSC,TRATIO,SRATIO,YR,CR,BK)

C     THIS SUBROUTINE FINDS THE VALUE OF B FOR THE EDGE STIFFENED
C     CANTILEVER PORTION FOR GIVEN VALUES OF TRATIO, SRATIO, YR AND CR

      DIMENSION A1(11),A2(11),A3(11),A4(11),B1(11),B2(11),B3(11),B4(11)
      DIMENSION BSC(2,6,6,6)
      COMMON/C9/BSC1(2),BSC2(6),BSC3(6),BSC4(6)

      DO 50 I1=1,2
      DO 40 I2=1,6
      BT=BSC(I1,I2,1,1)
      DO 30 I3=1,6
      IF(I3.EQ.1) GOTO 20
      DO 10 I4=1,I3
      A4(I4)=BSC4(I4)
      B4(I4)=BSC(I1,I2,I3,I4)
 10   CONTINUE
      N4=I3
      CALL INTERP(A4,B4,N4,CR,BT)
 20   CONTINUE
      A3(I3)=BSC3(I3)
      B3(I3)=BT
 30   CONTINUE
      N3=6
      CALL INTERP(A3,B3,N3,YR,BT)
      A2(I2)=BSC2(I2)
      B2(I2)=BT
 40   CONTINUE
      N2=6
      CALL INTERP(A2,B2,N2,SRATIO,BT)
      A1(I1)=BSC1(I1)
      B1(I1)=BT
 50   CONTINUE
      N1=2
      CALL INTERP(A1,B1,N1,TRATIO,BT)
      BK=BT
      RETURN
      END

      SUBROUTINE BINT(BI,TRATIO,SRATIO,YR,CR,BK)

C     THIS SUBROUTINE FINDS VALUE OF B FOR THE INTERNAL PANEL FOR GIVEN
C     VALUES OF TRATIO, SRATIO, YR AND CR

      DIMENSION A1(11),A2(11),A3(11),A4(11),B1(11),B2(11),B3(11),B4(11)
      DIMENSION BI(4,5,11,6)
      COMMON/C3/BI1(4),BI2(5),BI3(11),BI4(6)

      DO 40 I1=1,4
      DO 30 I2=1,5
      DO 20 I3=1,11
      DO 10 I4=1,6
      A4(I4)=BI4(I4)
      B4(I4)=BI(I1,I2,I3,I4)
 10   CONTINUE
      N4=6
      CALL INTERP(A4,B4,N4,CR,BT)
      A3(I3)=BI3(I3)
      B3(I3)=BT
 20   CONTINUE
      N3=11
      CALL INTERP(A3,B3,N3,YR,BT)
      A2(I2)=BI2(I2)
      B2(I2)=BT
 30   CONTINUE
      N2=5
      CALL INTERP(A2,B2,N2,SRATIO,BT)
      A1(I1)=BI1(I1)
      B1(I1)=BT
 40   CONTINUE
      N1=4
      CALL INTERP(A1,B1,N1,TRATIO,BT)
      BK=BT
      RETURN
      END

      SUBROUTINE BSINT(BSI,TRATIO,SRATIO,YR,CR,BK)

C     THIS SUBROUTINE FINDS VALUE OF B FOR THE EDGE STIFFENED INTERNAL
C     PANEL FOR GIVEN VALUES OF TRATIO, SRATIO, YR AND CR

      DIMENSION A1(11),A2(11),A3(11),A4(11),B1(11),B2(11),B3(11),B4(11)
      DIMENSION BSI(2,5,11,6)
      COMMON/C10/BSI1(2),BSI2(5),BSI3(11),BSI4(6)

      DO 40 I1=1,2
      DO 30 I2=1,5
      DO 20 I3=1,11
      DO 10 I4=1,6
      A4(I4)=BSI4(I4)
      B4(I4)=BSI(I1,I2,I3,I4)
 10   CONTINUE
      N4=6
      CALL INTERP(A4,B4,N4,CR,BT)
      A3(I3)=BSI3(I3)

      B3(I3)=BT
 20   CONTINUE
      N3=11
      CALL INTERP(A3,B3,N3,YR,BT)
      A2(I2)=BSI2(I2)

      B2(I2)=BT
 30   CONTINUE
      N2=5
      CALL INTERP(A2,B2,N2,SRATIO,BT)
      A1(I1)=BSI1(I1)

      B1(I1)=BT
 40   CONTINUE
      N1=2
      CALL INTERP(A1,B1,N1,TRATIO,BT)
c      write(*,*) 'tr=',tratio, 'bt=',bt
      BK=BT
      RETURN
      END

      SUBROUTINE INTERP(AA,BB,N,AT,BT)

C     GIVEN N PAIRS OF VALUES OF AA AND BB, THIS SUBROUTINE FINDS BT
C     FOR A GIVEN VALUE OF AT BY USING LAGRANGE'S INTERPOLATION FORMULA

      DIMENSION AA(11),BB(11)

      DO 10 I=1,N-1
      IF(ABS(AT-AA(I)).LT.0.0001) THEN
      BT=BB(I)
C      RETURN
      ELSE
      IF(AT.LE.AA(I).AND.AT.GE.AA(I+1)) THEN
      FK=(AT-AA(I))/(AA(I+1)-AA(I))
      BT=(BB(I+1)-BB(I))*FK+BB(I)
C      RETURN
      ENDIF
      ENDIF
 10   CONTINUE
      RETURN
      END

      SUBROUTINE MOMENX(YREF,MTX,KC,NAXLE,NLINES,BC,BI,BSC,
     *BSI)

C     Given weights and coordinates of NLINE of wheels, this subroutine
C     calculates the moment intensities MTX in the cantilever segment,
C     or internal panel, at x=XVAL, along the specified reference
C     section YREF.

C     (KC=1 for cantilever; KC=2 for internal panel)

      PARAMETER (PI=3.141592654,MAXC1=15)
      DIMENSION BC(4,6,6,6),BI(4,5,11,6),BSC(2,6,6,6),BSI(2,5,11,6)
      REAL MTX,MY
      INTEGER EDGE
      COMMON /C1/ SC,S,TRATIO,SRATIO,YMIN,NLOAD,CSAW,NX,XVAL,EDGE
      COMMON /d2/ xx(maxc1),yline(maxc1),f(maxc1)

      Y=YREF
      IF(sratio.le.0.1) THEN
      yrc=y/sc
      else
      YRC=Y/SC
      YRI=Y/S
      ENDIF

      MTX=0.
      DO 30 I2=1,NAXLE
      X=XVAL-YLINE(I2)
      DO 20 I3=1,NLINES
      C=XX(I3)
      CR=C/SC

      IF(EDGE.EQ.1) THEN
      IF(KC.EQ.1) CALL BSCAN(BSC,TRATIO,SRATIO,YRC,CR,BK)
      IF(KC.EQ.2) CALL BSINT(BSI,TRATIO,SRATIO,YRI,CR,BK)
      ELSE
      IF(KC.EQ.1) CALL BCAN(BC,TRATIO,SRATIO,YRC,CR,BK)
      IF(KC.EQ.2) CALL BINT(BI,TRATIO,SRATIO,YRI,CR,BK)
      ENDIF

      P=F(I2)
      IF(BK.EQ.0.) MY=0.
      IF(BK.EQ.0.) GOTO 20
      IF(X.EQ.0.) MY=2.*P*BK/PI
      IF(X.EQ.0.) GOTO 20
      IF(KC.EQ.2) GOTO 10
      Q1=(2.*P*BK/PI)
      Q2=(C-Y)**4
      Q3=((C-Y)*(C-Y)+BK*BK*X*X)**2
      MY=Q1*Q2/Q3
      GOTO 20
 10   Q1=(2.*P*BK/PI)
      Q2=(C**4)*((S-Y)**4)
      Q3=(C*C*(S-Y)*(S-Y)+(S*BK*X)**2)**2
      MY=Q1*Q2/Q3
 20   MTX=MTX+MY
 30   CONTINUE
      RETURN
      END

      SUBROUTINE DECAS(HC,ACM,AIM,asc,ASI)

C     This subroutine calculates for each section with subroutine AREA
C     the required area of reinforced steel needed to resist the applied
C     moment. It also chooses a design with subroutine SELECT that
C     matches the calculate areas.The 'd' value for each section have
C     been previously stored in DC; the applied moment have been stored
C     in ACM and AIM; the resulting areas are stored in ASC and ASI;the
C     resulting design is stored in CHOSEC and CHOSEI.

      DIMENSION HC(11),ACM(11),AIM(11),ASC(11),ASI(11),NSECTC(11),
     *NSECTI(11),CHOSEC(11,5),CHOSEI(11,5),SIZE(40,2),CHOICE(5),
     *SECT(40)
      CHARACTER *25 CHOSEC,CHOSEI,CHOICE,SECT,solu*1
      REAL KF,MR,MRC,MF,MACM,MAIM
      COMMON /C6/ PHIS,PHIC,B,RHOMIN,FY,FC
      COMMON /C7/ NSECTC,NSECTI,CHOSEC,CHOSEI
      COMMON /C8/ SIZE,SECT,COVR
      COMMON /d3/ solu

      DO 30 I1=1,11
      H=HC(I1)
      D=H-COVR-8
      MF=ACM(I1)
      IF(MF.LT.1E-3) MF=0.
 10   KF=MF*1000000./(B*D*D)

      IF(KF.LT.0.) THEN
      AS=999999.
      GOTO 15
      ENDIF

      CALL AREA(KF,D,H,AS)
 15   CALL SELECT(AS,CHOICE,NBSECT,ASR,BD)
      DR=H-COVR-(BD*0.5)

      IF(DR.LT.D) THEN
      D=DR
      GOTO 10
      ENDIF

      D=DR
      RHOR=ASR/(B*D)
      MR=(1.E-6)*RHOR*PHIS*FY*(1.-(RHOR*PHIS*FY)/(1.7*PHIC*FC))*B*D*D
      MRC=(1E-6)*0.083*B*H*SQRT(FC)
      IF(MR.LT.0.) MR=9999999.
      IF(MRC.LT.0.) MR=9999999.

      IF(MR.LT.(1.2*MRC)) THEN
      MACM=ACM(I1)

      IF(MR.LT.(1.33*MACM)) THEN
      KA=(1.2E6)*MRC/(B*D*D)
      KB=(1.33E6)*MACM/(B*D*D)
      KF=MIN(KA,KB)
      MF=(1.E-6)*KF*B*D*D
      CALL AREA(KF,D,H,AS)
      GOTO 15
      ENDIF
      ENDIF

      ASC(I1)=AS
      NSECTC(I1)=NBSECT
      DO 20 I=1,5
      CHOSEC(I1,I)=CHOICE(I)
 20   CONTINUE
 30   CONTINUE
      H=HC(11)
      D=H-COVR-8
      DO 60 I2=1,11
      MF=AIM(I2)
      IF(MF.LT.(1E-3)) MF=0.
 40   KF=MF*1000000./(B*D*D)

      IF(KF.LT.0.) THEN
      AS=999999.
      GOTO 45
      ENDIF

      CALL AREA(KF,D,H,AS)
 45   CALL SELECT(AS,CHOICE,NBSECT,ASR,BD)
      DR=H-COVR-(BD*0.5)

      IF(DR.LT.D) THEN
      D=DR
      GOTO 40
      ENDIF

      D=DR
      RHOR=ASR/(B*D)
      MR=(1E-6)*RHOR*PHIS*FY*(1-(RHOR*PHIS*FY)/(1.7*PHIC*FC))*B*D*D
      MRC=(1E-6)*0.083*B*H*SQRT(FC)
      IF(MR.LT.0.) MR=9999999.
      IF(MRC.LT.0.) MR=9999999.

      IF(MR.LT.(1.2*MRC)) THEN
      MAIM=AIM(I2)
      IF(MR.LT.(1.33*MAIM)) THEN
      KA=(1.2E6)*MRC/(B*D*D)
      KB=(1.33E6)*MAIM/(B*D*D)
      KF=MIN(KA,KB)
      MF=(1.E-6)*KF*B*D*D
      CALL AREA(KF,D,H,AS)
      GOTO 45
      ENDIF
      ENDIF

      ASI(I2)=AS
      NSECTI(I2)=NBSECT
      DO 50 I0=1,5
      CHOSEI(I2,I0)=CHOICE(I0)
 50   CONTINUE
 60   CONTINUE
      RETURN
      END

      SUBROUTINE AREA(KF,D,H,AS)

C     This subroutine calculates the needed steel area AS in oder to get
C     KR>KF for a concrete section having d=D.

      REAL KF,KR
      INTEGER IROMAX
      COMMON /C6/ PHIS,PHIC,B,RHOMIN,FY,FC

      RHO=0.
      AS=0.
      BETA=0.85-0.08*(FC-30.)*0.1
      IF(BETA.LT.0.65) BETA=0.65
      IF(BETA.GT.0.85) BETA=0.85
      IROMAX=4250*BETA*PHIC*FC/(PHIS*FY)
      DO 10 I1=1,IROMAX
      RHOI=I1*0.0001
      KR=RHOI*PHIS*FY*(1.-(RHOI*PHIS*FY)/(1.7*PHIC*FC))
      IF(KR.GE.KF) GOTO 20
 10   CONTINUE
      IF(KR.LT.KF) AS=999999.
      RETURN
 20   RHO=RHOI
      AS1=RHO*B*D
      AS2=RHOMIN*B*H
      AS=MAX(AS1,AS2)
      IF(AS.LT.0.) AS=999999.
      RETURN
      END

      SUBROUTINE SELECT(AS,CHOICE,NBSECT,ASR,BD)

C     This subroutine selects suitable choices of rebar patterns that
C     match AS. More than one choice is made for each section (i.e.
C     for each AS.)

      DIMENSION SIZE(40,2),SECT(40),CHOICE(5)
      CHARACTER *25 CHOICE,SECT
      COMMON /C8/ SIZE,SECT

      DO 10 I0=1,5
      CHOICE(I0) =' '
 10   CONTINUE
      NBSECT=0
      ASR=0.
      BD=0.
      DO 20 I1=1,40
      IF(SIZE(I1,1).GE.AS) GOTO 30
 20   CONTINUE
      CHOICE(1)='Moment too large'
      NBSECT=1
      ASR=AS
      GOTO 50
 30   ASR=SIZE(I1,1)
      BD=SIZE(I1,2)
      NBI1=I1
 40   NBSECT=NBSECT+1
      CHOICE(NBSECT)=SECT(NBI1)
      NBI1=NBI1+1
      IF(NBI1.GE.40) GOTO 50
      IF(SIZE(NBI1,1) .EQ. SIZE(I1,1)) GOTO 40
 50   CONTINUE
      RETURN
      END

      FUNCTION fa(x)

C     This function is thises equation's (1-6) the first dirivative.

      PARAMETER (maxc1=15,pi=3.141592654)
      DIMENSION bb(maxc1)
      COMMON /D2/ xx(maxc1),yline(maxc1),f(maxc1)
      COMMON /D4/ bb,naxle,nline
      COMMON /D5/ yref

      fa=0.
      do 10 i=1,nline
      do 10 j=1,naxle
      fa=fa-8*f(j)*bb(i)**3*(yline(j)-x)*(xx(i)-yref)**4/pi/
     *((xx(i)-yref)**2+bb(i)**2*(yline(j)-x)**2)**3
 10   CONTINUE
      RETURN
      END

      SUBROUTINE DHRT1(a,b,h,eps,x,n,m,KC)

C     This subroutine obtains the equation fa(x)=0 all real roots in
C     regine (0,yline(naxle))

      DIMENSION x(n)
      COMMON /D5/ yref

      m=0
      z=a
      IF(KC.EQ.1) y=fa(z)
      IF(KC.EQ.2) Y=FB(Z)
 10   IF((z.gt.b+h*0.5).or.(m.eq.n)) RETURN

      IF(abs(y).lt.eps) THEN
      m=m+1
      x(m)=z
      z=z+h*0.5
      IF(KC.EQ.1) y=fa(z)
      IF(KC.EQ.2) Y=FB(Z)
      GOTO 10
      ENDIF

      z1=z+h
      IF(KC.EQ.1) y1=fa(z1)
      IF(KC.EQ.2) Y1=FB(Z1)

      IF(abs(y1).lt.eps) THEN
      m=m+1
      x(m)=z1
      z=z1+h*0.5
      IF(KC.EQ.1) y=fa(z)
      IF(KC.EQ.2) Y=FB(Z)
      GOTO 10
      ENDIF

      IF(y*y1.gt.0.) THEN
      y=y1
      z=z1
      GOTO 10
      ENDIF

 20   IF(abs(z1-z).lt.eps) THEN
      m=m+1
      x(m)=(z1+z)*0.5
      z=z1+h*0.5
      IF(KC.EQ.1) y=fa(z)
      IF(KC.EQ.2) Y=FB(Z)
      GOTO 10
      ENDIF

      z0=(z1+z)*0.5
      IF(KC.EQ.1) y0=fa(z0)
      IF(KC.EQ.2) Y0=FB(Z0)

      IF(abs(y0).lt.eps) THEN
      m=m+1
      x(m)=z0
      z=z0+h*0.5
      IF(KC.EQ.1) y=fa(z)
      IF(KC.EQ.2) Y=FB(Z)
      GOTO 10
      ENDIF

      IF(y*y0.lt.0.) THEN
      z1=z0
      y1=y0
      else
      z=z0
      y=y0
      ENDIF

      GOTO 20
      END


      function fb(x)

C     This function is thises equation's (1-7) the first dirivetive

      parameter (maxc1=15,pi=3.141592654)
      dimension bb(maxc1)
      COMMON /c1/ SC,S,TRATIO,SRATIO,YMIN,NLOAD,CSAW,NX,XVAL,EDGE
      COMMON /d2/ xx(maxc1),yline(maxc1),f(maxc1)
      COMMON /d4/ bb,naxle,nline
      COMMON /d5/ yref

      fb=0.
      do 10 i=1,nline
      do 10 j=1,naxle

      IF(yref.LT.s) THEN
      fb=fb-8*f(j)*bb(i)**3*(yline(j)-x)*xx(i)**4*(S-yref)**4/pi/
     * ( xx(i)**2*(S-yref)**2+ S*S*bb(i)*bb(i)*(yline(j)-x)**2)**3
      ENDIF

 10   CONTINUE
      RETURN
      END

